"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.$ = void 0;
var React = require("react");
var rxjs_1 = require("rxjs");
function $(props) {
    var children = props === null || props === void 0 ? void 0 : props.children;
    // store children
    var _a = React.useState(null), cn = _a[0], setCn = _a[1];
    var _b = React.useState(null), error = _b[0], setError = _b[1];
    React.useEffect(function () {
        // multiple children, one of em might be observable
        if (Array.isArray(children)) {
            setCn(children.map(function (c) { return React.createElement($, null, c); }));
            return;
        }
        // single observable child
        if (rxjs_1.isObservable(children)) {
            var sub_1 = children.subscribe({
                next: function (cn) {
                    // update the view
                    setCn(cn);
                },
                error: function (error) {
                    // wrap error in an object to be safe in case the error is nullish
                    setError({ error: error });
                }
            });
            return function () { return sub_1.unsubscribe(); };
        }
        // child is just a child
        setCn(children);
    }, [children]);
    // raise an error if Observable failed
    if (error) {
        throw error.error;
    }
    // render children as array
    return Array.isArray(cn)
        ? React.createElement.apply(React, __spreadArrays([React.Fragment, null], cn)) : React.createElement(React.Fragment, null, cn);
}
exports.$ = $;
